# Variables
if (Test-Path variable:global:$env:BUILD_NUMBER) {
	$build_num = $env:BUILD_NUMBER
} else {
	$build_num = '0'
}

# Remove old artifacts
rm -r build/*
rm -r dist/*

# Build the agent.exe service
pip install -r .\requirements.txt
pip install -r .\requirements-opt.txt
pip install .\packaging\win32\install_files\py2exe-0.6.9.zip
rm -r C:\Python27\Lib\site-packages\py2exe\boot_service.py
cp -r .\packaging\win32\install_files\boot_service.py C:\Python27\Lib\site-packages\py2exe\
pip install .\guidata-1.7.6-py2.py3-none-any.whl
pip install pyVim
pip install pyVmomi
pip install pywin32
pip install Crypto
mv C:\Python27\lib\site-packages\PyQt4\uic\port_v3 to C:\Python27\lib\site-packages\PyQt4\uic\port_v3_
python setup.py py2exe

cp dist\*.* packaging\win32\install_files\files
cp dist\Microsoft.VC90.CRT\* packaging\win32\install_files\Microsoft.VC90.CRT\

# Change to the packaging directory
cd packaging\win32

# Copy checks.d files into the install_files
mkdir install_files\checks.d
cp ..\..\collector\checks.d\* install_files\checks.d

# Copy the conf.d files into the install_files
mkdir install_files\conf.d
cp ..\..\conf.d\* install_files\conf.d

# Copy JMX Fetch into the install_files
cp -R ..\..\dist\jmxfetch install_files\files\jmxfetch

# Copy JMX Fetch into the install_files
cp -R ..\..\dist\gohai install_files\files\gohai

# Move the images needed for the gui
cp -R install_files\guidata install_files\files

# Copy the license file
cp ..\..\LICENSE install_files\license.rtf

#Copy the Status template
cp ..\..\win32\status.html install_files\files

## Generate the CLI installer with WiX

    # Generate fragments for the files in checks.d, conf.d and pup
    heat dir install_files\files -gg -dr INSTALLDIR -t wix\files.xslt -var var.InstallFilesBins -cg files -o wix\files.wxs
    heat dir install_files\checks.d -gg -dr INSTALLDIR -var var.InstallFilesChecksD -cg checks.d -o wix\checksd.wxs
    heat dir install_files\conf.d -gg -dr APPLICATIONDATADIRECTORY -t wix\confd.xslt -var var.InstallFilesConfD -cg conf.d -o wix\confd.wxs

    # Create .wixobj files from agent.wxs, confd.wxs, checksd.wxs
    $opts = '-dInstallFiles=install_files', '-dWixRoot=wix', '-dInstallFilesChecksD=install_files\checks.d', '-dInstallFilesConfD=install_files\conf.d', '-dInstallFilesBins=install_files\files', "-dAgentVersion=4.7.5"
    candle $opts wix\agent.wxs wix\checksd.wxs wix\confd.wxs wix\files.wxs -ext WixUIExtension -ext WixUtilExtension

    # Light to create the msi
    light agent.wixobj checksd.wixobj confd.wixobj files.wixobj -ext WixUIExtension -ext WixUtilExtension -loc wix\localization-en-us.wxl -o ..\..\build\CiAgent.msi

# Clean up
rm *wixobj*
rm -r install_files\files\guidata
rm -r install_files\files\jmxfetch
rm -r install_files\files\gohai
rm install_files\files\*.*
rm -r install_files\conf.d
rm -r install_files\checks.d

# Move back to the root workspace
cd ..\..\

# Sign the installers
# TODO
